package iterate;

import mandel.StopWatch;

// Created on 02.07.2004 by RST
// $Id:$

public class IterateJava
{
	/**
	 * Iterates the mandelbrot set. takes xd instead of x2 as input.
	 */
	public static int iterateJava2(double x1, double dx, double y1, double dy, int i, int w, int h, int buffer[])
	{
		System.out.println("Iterating: x1=" + x1 + " y1=" +y1);
		double xs, ys;

		double x, y;
		double e, f;

		xs = x1;
		for (int px = 0; px < w; px++)
		{
			ys = y1;
			for (int py = 0; py < h; py++)
			{
				int count = 0;
				x = xs;
				y = ys;
				do
				{
					e = x * x;
					f = y * y;
					y = 2.0 * x * y + ys;
					x = e - f + xs;
					count++;
				}
				while (count < i && ((e + f) < 4.0)); 
				buffer[px * h + py] = count;
				ys += dy;
			}
			xs += dx;
		}
		return 0;
	}
	/**
	 * Iterates the mandelbrot set.
	 */
	public static int iterate(double x1, double x2, double y1, double y2, int i, int w, int h, int buffer[])
	{
		double xd = (x2 - x1) / (w - 1);
		double yd = (y2 - y1) / (h - 1);

		double xs, ys;

		double x, y;
		double e, f;

		xs = x1;
		for (int px = 0; px < w; px++)
		{
			ys = y1;
			for (int py = 0; py < h; py++)
			{
				int count = 0;
				x = xs;
				y = ys;
				do
				{
					e = x * x;
					f = y * y;
					y = 2.0 * x * y + ys;
					x = e - f + xs;
					count++;
				}
				while (count < i && ((e + f) < 4.0));
				buffer[px * h + py] = count;
				ys += yd;
			}
			xs += xd;
		}
		return 0;
	}

	/**
	 * Mandelbrot console test program.
	 */
	public static void main(String args[])
	{
	}
}
