package mandel;
import java.awt.Color;

public class ColorMapper
{
	
	/** For later use. */
	public static void setColorMode(int mode)
	{
		colormode=mode;
	}
	
	/** Not used yet. */
	private static int colormode =0;
	
	
	/** Returns normal color range. */
	public static Color getColor(int index)
	{
		if (index >= 0 && index < 256)
			return new Color(index, index, index);
		else
			return new Color(0, 0, 0);
	}
	
	/** Returns normal color range. */
	public static int[] getRGB(int index)
	{
		if (index >= 0 && index < 256)
			return new int[]{index, index, index};
		else
			return new int[]{0, 0, 0};
	}
	
	/** Returns ping pong color. */
	public static Color getColorPlus(int index)
	{
		int i2 = index % (256 + 255);
		
		if (i2 < 256)
			return getColor(i2);
		
		return getColor(256 + 255 - i2);	
	}
	
	/** Returns ping pong color. */
	public int[] getRGBPlus(int index)
	{
		int i2 = index % (256 + 255);
		
		if (i2 < 256)
			return getRGB(i2);
		
		return getRGB(256 + 255 - i2);		
	}
}
