package mandel;
import java.applet.Applet;
import java.applet.AppletContext;
import java.applet.AppletStub;
import java.applet.AudioClip;
import java.awt.Event;
import java.awt.Frame;
import java.awt.Image;
import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.MenuItem;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.net.URL;
import java.util.Enumeration;

public class MandelFrame extends Frame implements AppletStub
{

	private MandelMain myApplet;

	// Constructor:
	public MandelFrame(MandelMain mapp)
	{
		myApplet= mapp;
		setTitle("Mandelbrot Renderer");
		MenuBar mb= new MenuBar();
		Menu fileMenu= new Menu("File");
		fileMenu.add(new MenuItem("About"));
		fileMenu.add(new MenuItem("Exit"));
		mb.add(fileMenu);
		setMenuBar(mb);
		resize(700, 500);
		add("Center", mapp);
		mapp.setStub(this);
		mapp.init();
		show();
		mapp.start();
		addComponentListener(
			new ComponentAdapter() 
			{
			   public void componentResized(ComponentEvent event)
			   {
			   }
			}
		 );
		addWindowListener(
			new WindowAdapter() {
			   public void windowClosing(WindowEvent event)
			   {
				  System.exit(0);
			   }
			}
		 );
		
	} 

	// handleEvent() in this case simply destroys the frame
	// if the window is closed.
	public boolean handleEvent(Event evt)
	{
		if (evt.id == Event.WINDOW_DESTROY)
		{
			System.exit(0);
		}
		return super.handleEvent(evt);
	}

	// action() handles all user events, such as drop-down box
	// selects, text input, and button clicks.
	public boolean action(Event evt, Object arg)
	{
		if (evt.target instanceof MenuItem)
		{
			if (arg.equals("About"))
			{
				myApplet.about();
			}
			else
				if (arg.equals("Exit"))
				{
					System.exit(0);
				}
		} 
		else
			return false;
		return true;
	}

	// The following methods overload the AppletStub and
	// AppletContext methods, making them useless.  They
	// are included to keep the program from blowing up
	// on the off chance one might be called.

	// AppletStub methods
	public boolean isActive()
	{
		return true;
	}
	public URL getDocumentBase()
	{
		return null;
	}
	public URL getCodeBase()
	{
		return null;
	}
	public String getParameter(String name)
	{
		return "";
	}
	public AppletContext getAppletContext()
	{
		return null;
	}
	public void appletResize(int width, int height)
	{
		System.out.println("resize:" + width + "  " + height);
	}

	
	// AppletContext methods
	public AudioClip getAudioClip(URL url)
	{
		return null;
	}
	public Image getImage(URL url)
	{
		return null;
	}
	public Applet getApplet(String name)
	{
		return null;
	}
	public Enumeration getApplets()
	{
		return null;
	}
	public void showDocument(URL url)
	{
	}
	public void showDocument(URL url, String target)
	{
	}
	public void showStatus(String status)
	{
	}

} // MandelFrame
