// Created on 4.7.2004 by RST.
// $Id:$

package mandel;
import java.io.BufferedReader;
import java.io.FileReader;
import java.util.Iterator;
import java.util.Vector;


public class PresetManager extends Vector
{

	public void load(String fname) throws Exception
	{
		FileReader fr= new FileReader(fname);
		BufferedReader br= new BufferedReader(fr);

		while (br.ready())
		{
			String name= br.readLine();
			double x1= new Double(br.readLine()).doubleValue();
			double x2= new Double(br.readLine()).doubleValue();
			double y1= new Double(br.readLine()).doubleValue();
			double y2= new Double(br.readLine()).doubleValue();
			int iter= Integer.parseInt(br.readLine());
			addElement(new Preset(name, x1, x2, y1, y2, iter));
		}
	}
	
	public Preset findPreset(String what)
	{

		for (Iterator iter= iterator(); iter.hasNext();)
		{
			Preset p= (Preset) iter.next();
			if (p.name.equals(what))
				return p;
		}
		return null;
	}
	
	public void init()
	{
		removeAllElements();

		double x1, x2, y1, y2;
		int iter= 100;

		String name= "Mandelbrot Set";

		x1= -2.25;
		x2= 0.75;
		y1= -1.5;
		y2= 1.5;

		addElement(new Preset(name, x1, x2, y1, y2, iter));
		name= "Mandelbrot Lightning";

		x1= -0.1992;
		x2= -0.12954;
		y1= 1.0148;
		y2= 1.06707;

		addElement(new Preset(name, x1, x2, y1, y2, iter));
		name= "Electric Turtle 1";

		x1= -0.95;
		x2= -0.88333;
		y1= 0.23333;
		y2= 0.3;

		addElement(new Preset(name, x1, x2, y1, y2, iter));
		name= "Electric Turtle 2";

		x1= -0.713;
		x2= -0.4082;
		y1= 0.49216;
		y2= 0.71429;

		addElement(new Preset(name, x1, x2, y1, y2, iter));
		name= "Spiny Ridge";

		x1= -1.781;
		x2= -1.764;
		y1= 0;
		y2= 0.013;

		addElement(new Preset(name, x1, x2, y1, y2, iter));
		name= "Tide of Chaos";

		x1= -0.75104;
		x2= -0.7406;
		y1= 0.10511;
		y2= 0.11536;

		addElement(new Preset(name, x1, x2, y1, y2, iter));
		name= "The Wheel";

		x1= -0.74758;
		x2= -0.74624;
		y1= 0.10671;
		y2= 0.10779;

		addElement(new Preset(name, x1, x2, y1, y2, iter));
		name= "Invasion!";

		x1= -0.746541;
		x2= -0.746378;
		y1= 0.107574;
		y2= 0.107678;

		addElement(new Preset(name, x1, x2, y1, y2, iter));
		name= "The Tentacle";

		x1= -0.74591;
		x2= -0.74448;
		y1= 0.11196;
		y2= 0.11339;

		addElement(new Preset(name, x1, x2, y1, y2, iter));
		name= "Aurora Borealis";

		x1= -0.745538;
		x2= -0.745054;
		y1= 0.112881;
		y2= 0.113236;

		addElement(new Preset(name, x1, x2, y1, y2, iter));
		name= "Swirling Masses";

		x1= -0.745468;
		x2= -0.745385;
		y1= 0.112979;
		y2= 0.113039;

		addElement(new Preset(name, x1, x2, y1, y2, iter));
		name= "It Lives!";

		x1= -0.7454356;
		x2= -0.7454215;
		y1= 0.1130037;
		y2= 0.1130139;

		addElement(new Preset(name, x1, x2, y1, y2, iter));
		name= "Frenzy";

		x1= -1.254024;
		x2= -1.252861;
		y1= 0.046252;
		y2= 0.047125;

		addElement(new Preset(name, x1, x2, y1, y2, iter));

		x1= -2.25;
		x2= 0.75;
		y1= -1.5;
		y2= 1.5;

		try
		{
			load("rst-presets.txt");
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
}